3 Sum

Question

Problem Statement

Given an array S of n integers, are there elements a, b, c in S
such that a + b + c = 0? Find all unique triplets in the array which
gives the sum of zero.

Note:

The solution set must not contain duplicate triplets.

  1. For example, given array S = [-1, 0, 1, 2, -1, -4],
  2. A solution set is:
  3. [
  4. [-1, 0, 1],
  5. [-1, -1, 2]
  6. ]

题解1 - 排序 + 哈希表 + 2 Sum

相比之前的 2 Sum, 3 Sum 又多加了一个数,按照之前 2 Sum 的分解为『1 Sum + 1 Sum』的思路,我们同样可以将 3 Sum 分解为『1 Sum + 2 Sum』的问题,具体就是首先对原数组排序,排序后选出第一个元素,随后在剩下的元素中使用 2 Sum 的解法。

Python

  1. class Solution:
  2. """
  3. @param numbersbers : Give an array numbersbers of n integer
  4. @return : Find all unique triplets in the array which gives the sum of zero.
  5. """
  6. def threeSum(self, numbers):
  7. triplets = []
  8. length = len(numbers)
  9. if length < 3:
  10. return triplets
  11. numbers.sort()
  12. for i in xrange(length):
  13. target = 0 - numbers[i]
  14. # 2 Sum
  15. hashmap = {}
  16. for j in xrange(i + 1, length):
  17. item_j = numbers[j]
  18. if (target - item_j) in hashmap:
  19. triplet = [numbers[i], target - item_j, item_j]
  20. if triplet not in triplets:
  21. triplets.append(triplet)
  22. else:
  23. hashmap[item_j] = j
  24. return triplets

源码分析

  1. 异常处理,对长度小于3的直接返回。
  2. 排序输入数组,有助于提高效率和返回有序列表。
  3. 循环遍历排序后数组,先取出一个元素,随后求得 2 Sum 中需要的目标数。
  4. 由于本题中最后返回结果不能重复,在加入到最终返回值之前查重。

由于排序后的元素已经按照大小顺序排列,且在2 Sum 中先遍历的元素较小,所以无需对列表内元素再排序。

复杂度分析

排序时间复杂度 O(n \log n), 两重for循环,时间复杂度近似为 O(n^2),使用哈希表(字典)实现,空间复杂度为 O(n).

目前这段源码为比较简易的实现,leetcode 上的运行时间为500 + ms, 还有较大的优化空间,嗯,后续再进行优化。

C++

  1. class Solution {
  2. public:
  3. vector<vector<int> > threeSum(vector<int> &num)
  4. {
  5. vector<vector<int> > result;
  6. if (num.size() < 3) return result;
  7. int ans = 0;
  8. sort(num.begin(), num.end());
  9. for (int i = 0;i < num.size() - 2; ++i)
  10. {
  11. if (i > 0 && num[i] == num[i - 1])
  12. continue;
  13. int j = i + 1;
  14. int k = num.size() - 1;
  15. while (j < k)
  16. {
  17. ans = num[i] + num[j] + num[k];
  18. if (ans == 0)
  19. {
  20. result.push_back({num[i], num[j], num[k]});
  21. ++j;
  22. while (j < num.size() && num[j] == num[j - 1])
  23. ++j;
  24. --k;
  25. while (k >= 0 && num[k] == num[k + 1])
  26. --k;
  27. }
  28. else if (ans > 0)
  29. --k;
  30. else
  31. ++j;
  32. }
  33. }
  34. return result;
  35. }
  36. };

Java

  1. public class Solution {
  2. public List<List<Integer>> threeSum(int[] nums) {
  3. // Assumptions: array is not null, array.length >= 3
  4. List<List<Integer>> result = new ArrayList<List<Integer>>();
  5. Arrays.sort(nums);
  6. for (int i = 0; i < nums.length - 2; i++) {
  7. if (i > 0 && nums[i] == nums[i - 1]) {
  8. continue;
  9. }
  10. int left = i + 1;
  11. int right = nums.length - 1;
  12. while (left < right) {
  13. int tmp = nums[left] + nums[right];
  14. if (tmp + nums[i] == 0) {
  15. result.add(Arrays.asList(nums[i], nums[left], nums[right]));
  16. left++;
  17. while (left < right && nums[left] == nums[left - 1]) {
  18. left++;
  19. }
  20. } else if (tmp + nums[i] < 0) {
  21. left++;
  22. } else {
  23. right--;
  24. }
  25. }
  26. }
  27. return result;
  28. }
  29. }

源码分析

同python解法不同,没有使用hash map

  1. S = {-1 0 1 2 -1 -4}
  2. 排序后:
  3. S = {-4 -1 -1 0 1 2}
  4. i j k
  5. i每轮只走一步,jk根据S[i]+S[j]+S[k]=ans0的关系进行移动,且j只向后走(即S[j]只增大),k只向前走(即S[k]只减小)
  6. 如果ans>0说明S[k]过大,k向前移;如果ans<0说明S[j]过小,j向后移;ans==0即为所求。
  7. 至于如何取到所有解,看代码即可理解,不再赘述。

复杂度分析

外循环i走了n轮,每轮j和k一共走n-i步,所以时间复杂度为O(n^2)
最终运行时间为52ms

Reference